// ====================================================================
// Copyright (C) INRIA -  Serge Steer
// 
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at    
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// ====================================================================
path=get_absolute_file_path('test.sce');
//Dense storage
//---------------

//1 - Real case

//1.1 general
A=matrix(1:12,3,4);
mmwrite(TMPDIR+'/A.mtx',A) ; 
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'real'|symm<>'general'|norm(A1-A)>10*%eps then pause,end


//1.2 symetric
A=A'*A;
mmwrite(TMPDIR+'/A.mtx',A); 
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'real'|symm<>'symmetric'|norm(A1-A)>10*%eps then pause,end

//1.3 skewsymetric
A=A-2*triu(A,1);
mmwrite(TMPDIR+'/A.mtx',A)  ;
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'real'|symm<>'skew-symmetric'|norm(A1-A)>10*%eps then pause,end

//2 Complex case

//2.1 general
A=matrix(1:12,3,4);A(1,2)=A(1,2)+%i
mmwrite(TMPDIR+'/A.mtx',A) ; 
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'complex'|symm<>'general'|norm(A1-A)>10*%eps then pause,end

//2.2 symetric
A=A.'*A;
mmwrite(TMPDIR+'/A.mtx',A);  
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'complex'|symm<>'symmetric'|norm(A1-A)>10*%eps then pause,end


//2.3 skewsymetric
A=A-2*triu(A,1);
mmwrite(TMPDIR+'/A.mtx',A)  ;
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'complex'|symm<>'skew-symmetric'|norm(A1-A)>10*%eps then pause,end



//2.4 hermitian
A=matrix(1:12,3,4);A(1,2)=A(1,2)+%i
A=A'*A;
mmwrite(TMPDIR+'/A.mtx',A);  
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"array"|field<>'complex'|symm<>'hermitian'|norm(A1-A)>10*%eps then pause,end


//Sparse storage
//---------------

//1 - Real case

//1.1 general
A=sparse(matrix([0,0,3,4,0,0,0,8,9,0,11,0],3,4));
mmwrite(TMPDIR+'/A.mtx',A) ; 
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'real'|symm<>'general'|norm(A1-A)>10*%eps then pause,end

mmwrite(TMPDIR+'/A.mtx',A,[],'pattern')
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
A2=A;A2(find(A2<>0))=1;
if rep<>"coordinate"|field<>'pattern'|symm<>'general'|norm(A1-A2)>10*%eps then pause,end

//1.2 symetric
A=A'*A;
mmwrite(TMPDIR+'/A.mtx',A);  
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'real'|symm<>'symmetric'|norm(A1-A)>10*%eps then pause,end

mmwrite(TMPDIR+'/A.mtx',A,[],'pattern');  
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
A2=A;A2(find(A2<>0))=1;
if rep<>"coordinate"|field<>'pattern'|symm<>'symmetric'|norm(A1-A2)>10*%eps then pause,end


//1.3 skewsymetric
A=A-2*triu(A,1);
mmwrite(TMPDIR+'/A.mtx',A)  ;
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'real'|symm<>'skew-symmetric'|norm(A1-A)>10*%eps then pause,end

mmwrite(TMPDIR+'/A.mtx',A,[],'pattern')  ;
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
A2=A;A2(find(A>0))=1;A2(find(A<0))=-1;
if rep<>"coordinate"|field<>'pattern'|symm<>'skew-symmetric'|norm(A1-A2)>10*%eps then pause,end


//2 Complex case

//2.1 general
A=sparse(matrix([0,0,3,4,0,0,0,8,9,0,11,0],3,4));A(1,2)=A(1,2)+%i;
mmwrite(TMPDIR+'/A.mtx',A) ; 
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'complex'|symm<>'general'|norm(A1-A)>10*%eps then pause,end


//2.2 symetric
A=A.'*A;
mmwrite(TMPDIR+'/A.mtx',A);  
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'complex'|symm<>'symmetric'|norm(A1-A)>10*%eps then pause,end

//2.3 skewsymetric
A=A-2*triu(A,1);
mmwrite(TMPDIR+'/A.mtx',A)  ;
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'complex'|symm<>'skew-symmetric'|norm(A1-A)>10*%eps then pause,end



//2.4 hermitian
A=sparse(matrix([0,0,3,4,0,0,0,8,9,0,11,0],3,4));
A=A'*A;A(1,3)=A(1,3)+%i;A(3,1)=A(3,1)-%i;
mmwrite(TMPDIR+'/A.mtx',A);  
[A1,rows,cols,entries,rep,field,symm] = mmread(TMPDIR+'/A.mtx');
if rep<>"coordinate"|field<>'complex'|symm<>'hermitian'|norm(A1-A)>10*%eps then pause,end

--------------------------------------------------------------------------------------------
//test with files downloaded from http://math.nist.gov/MatrixMarket

F=listfiles(path+'*.mtx');
for f=F, disp(f),mmread(f);end

--------------------------------------------------------------------------------------------


// Check value provided here:
// http://math.nist.gov/MatrixMarket/data/SPARSKIT/tokamak/utm300.html

warning("off");
[rows,cols,entries,rep,field,symm,comments] = mminfo(path+"utm300.mtx")
if rows<>300|cols<>300 then pause,end
if entries<>3155 then pause,end
if field<>"real" then pause,end
if symm<>"general" then pause,end

A=mmread(path+"utm300.mtx");

mmwrite(TMPDIR+'/A.mtx',A,[],'real')
A1=mmread(TMPDIR+'/A.mtx');
if or(A<>A1) then pause,end

[nl,nc] = size(A)
if nl <> 300 then pause, end
if nc <> 300 then pause, end
if nnz(A) <> 3155 then pause, end

// Diagonal
if nnz(diag(A)) <> 300 then pause, end

// A-A'
if nnz(A-A') <> 4382 then pause, end

// Heaviest diagonals
offsets = [ 0 -50 50 1 -1 -5 5 2 -2 -4 ];
nonzerosExpected = [ 300 190 186 180 166 159 158 150 134 113 ];

for j=1:length(offsets)
	if nnz(diag(A, offsets(j))) <> nonzerosExpected(j) then pause, end
end

// TODO add the rest of information

[ij]=spget(A);
e=ij(:,1)-ij(:,2);

// Bandwidths average |i-j|
m=ceil(mean(abs(e)));
if m <> 21 then pause, end

// Bandwidths std.dev.
d=ceil(st_deviation(abs(e)));
if d <> 23 then pause, end

lastinrow=[find(diff(ij(:,1))>0) size(ij,1)];
rowlength=diff([0 lastinrow]);

// Row Data
[longest,indlongest]=max(rowlength);
if longest <> 33 then pause, end
if indlongest <> 116 then pause, end

[shortest,indshortest]=min(rowlength);
if shortest <> 1 then pause, end
if indshortest <> 3 then pause, end

// Average nonzeros per row 
m=ceil(mean(rowlength));
if m <> 11 then pause, end

d=round(st_deviation(rowlength)*10)/10;
if d <> 7.7 then pause, end

// Column Data
ji=gsort(ij(:,[2 1]),'lr','i');
lastincol=[find(diff(ji(:,1))>0) size(ji,1)];
collength=diff([0 lastincol]);

[longest,indlongest]=max(collength);
if longest <> 22 then pause, end
if indlongest <> 59 then pause, end

[shortest,indshortest]=min(collength);
if shortest <> 1 then pause, end
if indshortest <> 16 then pause, end

m=ceil(mean(collength));
if m <> 11 then pause, end

d=round(st_deviation(collength)*10)/10;
if d <> 7.1 then pause, end

// Profile Storage
lastinrow=[find(diff(ij(:,1))>0) size(ij,1)];
rowbounds= [ij([1 lastinrow(1:$-1)+1],2) ij(lastinrow,2)];
rowindex=ij(lastinrow,1);
rowbandwidth=rowbounds-rowindex*ones(1,2);
lowband=[-rowbandwidth(find(rowbandwidth(:,1)<=0),1)
         -rowbandwidth(find(rowbandwidth(:,2)<=0),2)];
uppband=[rowbandwidth(find(rowbandwidth(:,1)>=0),1)
         rowbandwidth(find(rowbandwidth(:,2)>=0),2)];   

// lower bandwidth => max
minlow=max(lowband);
if minlow <> 74 then pause, end

// lower bandwidth => min
maxlow=min(lowband);
if maxlow <> 0 then pause, end

// upper bandwidth => max
maxupp=max(uppband);
if maxupp <> 66 then pause, end

// upper bandwidth => min
minupp=min(uppband);
if minupp <> 0 then pause, end

